@ok-can-offline @admin-file @issue-457
Feature: A curator can manage file attributes in admin file update page
  As a curator
  I want to manage file attributes from the update form
  So that I can associate various attributes to files

  @ok
  Scenario: Guest user cannot visit admin file update page
    Given I have not signed in
    When I am on "/adminFile/update/"
    Then I should see "Login"

  @ok
  Scenario: Go to a published dataset
    Given I have not signed in
    When I am on "/dataset/100056"
    And I follow "History"
    Then I should see "File Termitomyces_assembly_v1.0.fa.gz updated"
    And I should see "File Termitomyces_gene_v1.0.cds.fa updated"
    And I should see "File Termitomyces_gene_v1.0.cds.fa updated"
    And I should see "File Termitomyces_gene_v1.0.gff updated"
    And I should see "File Termitomyces_gene_v1.0.gff updated"
    And I should see "File Termitomyces_gene_v1.0.pep.fa updated"
    And I should see "File Termitomyces_gene_v1.0.pep.fa updated"

  @ok @published
  Scenario: See Attribute, Edit, Delete, and Save buttons on admin file update page
    Given I have signed in as admin
    When I am on "/adminFile/update/id/13973"
    Then I should see create new file attribute link button
    And I should see a file attribute table
      | Attribute Name | Value     | Unit |
      | last_modified  | 2013-7-15 |      |
    And I should see edit file attribute link button
    And I should see delete file attribute link button
    And I should see a submit button "Save"

  @ok @published
  Scenario: See the File Attribute value of the last modified attribute on admin file view page
    Given I have signed in as admin
    When I am on "/adminFile/view/id/13973"
    Then I should see a view file table
      | File Attribute | 2013-7-15 |

  #TODO: Fix problem why this test can sometimes randomly fail
#  @javascript @published
#  Scenario: Delete a last modified attribute on admin file update page
#    Given I have signed in as admin
#    And I am on "/adminFile/update/id/13973"
#    When I press the button "Delete"
#    Then I should not see "last_modified"
#    And I should not see "2013-7-15"
#    And I should not see delete file attribute link button

  @ok @javascript @published
  Scenario: File Attribute value is empty after deleting an attribute and saving
    Given I have signed in as admin
    And I am on "/adminFile/update/id/13973"
    When I press the button "Delete"
    And I press the button "Save"
    Then I am on "/adminFile/view/id/13973"
    And I should not see "File Attribute"

  @ok @javascript @published
  Scenario: File attribute deletion is recorded in History tab
    Given I have signed in as admin
    When I am on "/adminFile/update/id/13973"
    And I press the button "Delete"
    And I press the button "Save"
    And I am on "/dataset/100056"
    And I should see "Termitomyces sp. J132 fungus genome assembly data."
    And I follow "History"
    Then I should see "Termitomyces_assembly_v1.0.fa.gz: file attribute deleted"

  @ok @nonPublished
  Scenario: See a keyword attribute and a camera parameters attribute on admin file update page
    Given I have signed in as admin
    When I am on "/adminFile/update/id/95354"
    Then I should see a file attribute table
      | Attribute Name    | Value                            | Unit |
      | keyword           | test Bauhinia                    |      |
      | camera parameters | test photo                       |      |
      | MD5 checksum      | b584eb4ce0947dbf9529acffc3e9f7cc |      |

  @ok @nonPublished
  Scenario: See File Attribute value on admin file view page
    Given I have signed in as admin
    When I am on "/adminFile/view/id/95354"
    Then I should see a view file table
      | File Attribute | test Bauhinia                    |
      | File Attribute | test photo                       |
      | File Attribute | b584eb4ce0947dbf9529acffc3e9f7cc |

  @ok @javascript @nonPublished
  Scenario: Delete a keyword attribute on admin file update page
    Given I have signed in as admin
    And I am on "/adminFile/update/id/95354"
    When I press the button "Delete"
    And I wait "0.3" seconds
    Then I should see a file attribute table
      | Attribute Name    | Value                            | Unit |
      | keyword           | test Bauhinia                       |      |
      | camera parameters | test photo |      |

  @ok @javascript @nonPublished
  Scenario: Delete camera parameters attribute and save, then check for File Attribute Value on admin file view page
    Given I have signed in as admin
    And I am on "/adminFile/update/id/95354"
    When I press the button "Delete"
    And I press the button "Save"
    Then I am on "/adminFile/view/id/95354"
    And I should see a view file table
      | File Attribute | test Bauhinia                       |
      | File Attribute | test photo |

  #TODO: Fix problem why this test can sometimes randomly fail
#  @javascript @nonPublished
#  Scenario: Delete last MD5 checksum file attribute from a non published dataset
#    Given I have signed in as admin
#    And I am on "/adminFile/update/id/95354"
#    When I press the button "Delete"
#    And I press the button "Delete"
#    And I press the button "Delete"
#    Then I should not see "test Bauhinia"
#    And I should not see "test photo"
#    And I should not see "b584eb4ce0947dbf9529acffc3e9f7cc"

  #TODO: Fix problem why this test can sometimes randomly fail
#  @javascript @published
#  Scenario: Check admin file view page is now empty after all file attributes have been deleted
#    Given I have signed in as admin
#    And I am on "/adminFile/update/id/95354"
#    When I press the button "Delete"
#    And I press the button "Delete"
#    And I press the button "Delete"
#    And I press the button "Save"
#    Then I am on "/adminFile/view/id/95354"
#    And I should not see "File Attribute"

  @ok @published
  Scenario: See the "Save Attribute" button on admin file update page
    Given I have signed in as admin
    And I am on "/adminFile/update/id/13973"
    When I press the button "Edit"
    And I wait 2 seconds
    Then I should see "Save Attribute"
    And I should see a submit button "Save"

  @ok @issue-2029
  Scenario: When both the edit from and the new attribute form are open, duplicate are not created
    Given I have signed in as admin
    And I am on "/adminFile/update/id/13973"
    And I press the button "Edit"
    And I press the button "Show New Attribute Fields"
    When I select "age" in menu "FileAttributes_new_attribute_id"
    And I fill in the text input "FileAttributes[new][value]" with "35"
    And I press the button "Add attribute"
    Then I should see a file attribute table
      | Attribute Name | Value     | Unit |
      | last_modified  | 2013-7-15 |      |
      | age            | 35        |      |

  @ok @issue-2066
  Scenario: Works for the new attribute's length value up to 1000
    Given I have signed in as admin
    And I am on "/adminFile/update/id/13973"
    And I press the button "Edit"
    And I press the button "Show New Attribute Fields"
    When I select "comment" in menu "FileAttributes_new_attribute_id"
    And I fill in the text input "FileAttributes[new][value]" with "embryophyta_odb10 C:99.1%[S:77.9%,D:21.2%],F:0.4%,M:0.5%,n:1614"
    And I press the button "Add attribute"
    Then I should see a file attribute table
      | Attribute Name | Value     | Unit |
      | last_modified  | 2013-7-15 |      |
      | comment        | embryophyta_odb10 C:99.1%[S:77.9%,D:21.2%],F:0.4%,... |      |

  @ok @issue-2066
  Scenario: I can edit in a very long attribute value
    Given I have signed in as admin
    And I am on "/adminFile/update/id/13973"
    And I press the button "Edit"
    And I wait "1" seconds
    And I fill in the text input "FileAttributes[edit][value]" with "Monday 15th July 2013, 00:00:00 AM Europe/Paris, 3463456435745634256234623456234562 bytes changed, version 235235.3423523"
    And I press the button "Save Attribute"
    Then I should see a file attribute table
      | Attribute Name | Value     | Unit |
      | last_modified  | Monday 15th July 2013, 00:00:00 AM Europe/Paris, 3... |      |

  @ok @issue-2066
  Scenario: I can expand the attribute value field for large input
    Given I have signed in as admin
    And I am on "/adminFile/update/id/447"
    And I press the button "Show New Attribute Fields"
    When I select "comment" in menu "FileAttributes_new_attribute_id"
    And I fill in the text input "FileAttributes[new][value]" with "This is a very long comment that needs a larger text field to be properly visible. It contains detailed information about file changes, timestamps, and other metadata that curators need to review carefully."
    And I press the button "Add attribute"
    Then I should see a file attribute table
      | Attribute Name | Value     | Unit |
      | comment  | This is a very long comment that needs a larger te...  |      |
    When I press the button "+"
    Then I should see a file attribute table
      | Attribute Name | Value     | Unit |
      | comment  | This is a very long comment that needs a larger text field to be properly visible. It contains detailed information about file changes, timestamps, and other metadata that curators need to review carefully.  |      |
    When I press the button "-"
    Then I should see a file attribute table
      | Attribute Name | Value     | Unit |
      | comment  | This is a very long comment that needs a larger te...  |      |
